unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,Lexical, Syntax2,StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LA:TLExicalAnalyzer;
  SA:TSyntaxAnalyzer;
  Rez:Boolean;


implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
 LA:=TLExicalAnalyzer.Create;
end;

procedure TForm1.Button1Click(Sender: TObject);

var R:tresult;
    mes:STRING;

begin
 SetLength(r,0);
 WITH LA DO
  BEGIN
   Run(Trim(edit1.Text));
   IF Error='' THEN
    begin
     r:=Lexem;
     SA:=TSyntaxAnalyzer.Create(r);
     SA.Parse;
      IF SA.error='' THEN
      mes:=' '

     ELSE
      BEGIN
       mes:=SA.error+' (. '+IntToStr(SA.errorpos)+')';
       WITH Edit1 DO
        BEGIN
         SetFocus;
         IF SA.errorpos<Length(Edit1.Text) THEN
          SelStart:=SA.errorpos
         ELSE
          SelStart:=Length(Edit1.Text)-1; 
         SelLength:=1
        END
      END;
     MessageDlg(mes,mtInformation,[mbOK],0);
     SA.Free;

    END
   ELSE
     MessageDlg(error,mtInformation,[mbOK],0);
  END
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 LA.Free
end;

end.
